//******************************************************************************
// mapa.h
// Fichero de definicin del mapa del juego.
// Por Ignacio Prez Gil 12/03/2008.
//******************************************************************************

//******************************************************************************
// Estructura para los datos de las habitaciones.
//******************************************************************************
#define NUM_HABS 129
struct{
 unsigned short n;        // Nmero de objetos en la habitacin

 unsigned char x_p;       // Los cuatro bits ms significativos indican la coordenada
                          // x de la habitacin. Los otros, la configuracin de las puertas.

 unsigned char tipo;      // Tipo de habitacin cuadrada (paredes y suelo)
 unsigned char banderas; // Banderas varias.
                          // Bit 7: sin uso.
                          // Bit 6: sin uso.
                          // Bit 5: sin uso.
                          // Bit 4: Habitacin visitada.
                          // Bit 3: cerradura abierta.
                          // Bits 1 y 2: nmero de llaves.
                          // Bit 0: habitacin cuadrada.
} hab[NUM_HABS]={
//   0              1              2              3
   {31,0x76,2,1}, {33,0x8c,2,1}, {31,0x75,0,0}, { 0,0x85,0,0},
//   4              5              6              7
   {34,0x66,2,1}, {36,0x7d,0,1}, {11,0x87,1,1}, {36,0x9c,2,1},
//   8              9             10             11
   {45,0x65,2,1}, {23,0x75,1,1}, {26,0x85,0,1}, {41,0x95,2,1},
//  12             13             14             15
   {59,0x56,2,1}, {26,0x69,2,1}, {16,0x75,0,0}, {50,0x85,0,0},
//  16             17             18             19
   {25,0x93,2,1}, {44,0xac,2,1}, {42,0x46,2,1}, {43,0x5f,1,1},
//  20             21             22             23
   {12,0x6c,0,1}, {27,0x75,0,0}, { 0,0x85,0,0}, {26,0x96,1,1},
//  24             25             26             27
   {32,0xaf,0,1}, {38,0xbc,2,1}, {43,0x36,2,1}, {35,0x4d,1,1},
//  28             29             30             31
   {19,0x53,0,1}, {59,0x69,1,1}, {16,0x75,0,0}, {24,0x85,0,0},
//  32             33             34             35
   {34,0x93,0,1}, {26,0xa9,1,1}, { 0,0xb7,0,1}, {29,0xcc,2,1},
//  36             37             38             39
   {30,0x26,2,1}, { 0,0x3b,1,1}, {27,0x4b,0,1}, { 0,0x5a,0,0},
//  40             41             42             43
   {36,0x6a,0,0}, {55,0x7f,1,1}, {40,0x8f,0,1}, { 2,0x9a,0,0},
//  44             45             46             47
   {18,0xaa,0,0}, {22,0xbb,1,1}, {28,0xcb,0,1}, {51,0xdc,2,1},
//  48             49             50             51
   {60,0x25,2,1}, {48,0x46,1,1}, {34,0x5e,0,1}, {40,0x6a,0,0},
//  52             53             54             55
   {47,0x7f,0,1}, {22,0x8f,1,1}, { 0,0x9a,0,0}, {31,0xae,1,1},
//  56             57             58             59
   {25,0xbc,0,1}, {40,0xd5,2,1}, {34,0x16,2,1}, {41,0x29,0,1},
//  60             61             62             63
   {47,0x47,0,1}, {50,0x59,1,1}, {14,0x75,0,0}, { 0,0x85,0,0},
//  64             65             66             67
   {46,0xa3,0,1}, {28,0xbd,1,1}, { 0,0xd3,1,1}, {59,0xec,2,1},
//  68             69             70             71
   { 0,0x15,0,0}, {34,0x45,0,0}, {45,0x64,1,1}, {18,0x75,0,0},
//  72             73             74             75
   {64,0x85,0,0}, {23,0x94,0,1}, {32,0xb5,0,0}, { 2,0xe5,0,0},
//  76             77             78             79
   {32,0x06,2,1}, {33,0x1f,2,1}, {26,0x2a,0,0}, {45,0x3c,1,1},
//  80             81             82             83
   {37,0x47,0,1}, {28,0x5a,0,0}, {32,0x6d,0,1}, { 0,0x75,0,0},
//  84             85             86             87
   {49,0x85,0,0}, { 4,0x97,1,1}, {30,0xaa,0,0}, {42,0xbd,1,1},
//  88             89             90             91
   {55,0xc6,0,1}, { 4,0xda,0,0}, {40,0xef,2,1}, {38,0xfc,2,1},
//  92             93             94             95
   {21,0x07,2,1}, {36,0x19,0,1}, {16,0x35,0,0}, {40,0x45,0,0},
//  96             97             98             99
   {35,0x63,1,1}, {28,0x7d,0,1}, {35,0x87,1,1}, {22,0x99,0,1},
// 100            101            102            103
   {55,0xb5,0,0}, { 8,0xc5,0,0}, {43,0xe3,1,1}, {47,0xfd,2,1},
// 104            105            106            107
   {23,0x01,2,1}, {42,0x35,0,0}, {16,0x45,0,0}, {28,0x73,1,1},
// 108            109            110            111
   {47,0x89,0,1}, { 0,0xb5,0,0}, { 0,0xc5,0,0}, {40,0xf1,2,1},
// 112            113            114            115
   {28,0x26,3,1}, {40,0x3f,3,1}, {36,0x4f,3,1}, {40,0x5c,3,1},
// 116            117            118            119
   {46,0xa6,3,1}, {20,0xbf,3,1}, {33,0xcf,3,1}, {62,0xdc,3,1},
// 120            121            122            123
   {42,0x23,3,1}, {31,0x3b,3,1}, {22,0x4b,3,1}, {29,0x59,3,1},
// 124            125            126            127
   {28,0xa3,3,1}, {25,0xbb,3,1}, {46,0xcb,3,1}, {37,0xd9,3,1},
// Reprogramando
   {90,0x00,0,1}};
#define HAB_REPROGRAMANDO 128

// Defines de coordenadas de columna
#define COL00 192
#define COL10 193
#define COL20 194
#define COL30 195
#define COL40 196
#define COL50 197
#define COL60 198
#define COL70 199
#define COL01 200
#define COL11 201
#define COL21 202
#define COL31 203
#define COL41 204
#define COL51 205
#define COL61 206
#define COL71 207
#define COL02 208
#define COL12 209
#define COL22 210
#define COL32 211
#define COL42 212
#define COL52 213
#define COL62 214
#define COL72 215
#define COL03 216
#define COL13 217
#define COL23 218
#define COL33 219
#define COL43 220
#define COL53 221
#define COL63 222
#define COL73 223
#define COL04 224
#define COL14 225
#define COL24 226
#define COL34 227
#define COL44 228
#define COL54 229
#define COL64 230
#define COL74 231
#define COL05 232
#define COL15 233
#define COL25 234
#define COL35 235
#define COL45 236
#define COL55 237
#define COL65 238
#define COL75 239
#define COL06 240
#define COL16 241
#define COL26 242
#define COL36 243
#define COL46 244
#define COL56 245
#define COL66 246
#define COL76 247
#define COL07 248
#define COL17 249
#define COL27 250
#define COL37 251
#define COL47 252
#define COL57 253
#define COL67 254
#define COL77 255

// Defines para elevacin de objetos.
#define ELEV0 0x80
#define ELEV1 0x81
#define ELEV2 0x82
#define ELEV3 0x83
#define ELEV4 0x84
#define ELEV5 0x85
#define ELEV6 0x86
#define ELEV7 0x87
#define ELEV8 0x88
#define ELEV9 0x89
#define ELEVA 0x8a
#define ELEVB 0x8b
#define ELEVC 0x8c
#define ELEVD 0x8d
#define ELEVE 0x8e
#define ELEVF 0x8f

// Objeto normal esttico
#define NOR00  0
#define NOR01  1
#define NOR02  2
#define NOR03 78 // Objeto normal oxidado
// Objeto normal que desaparece al pisarlo
#define NOR10  3
#define NOR11  4
#define NOR12  5
// Objeto normal que empuja +x
#define NOR20  6
#define NOR21  7
#define NOR22  8
// Objeto normal que empuja -x
#define NOR30  9
#define NOR31 10
#define NOR32 11
// Objeto normal que empuja +y
#define NOR40 12
#define NOR41 13
#define NOR42 14
// Objeto normal que empuja -y
#define NOR50 15
#define NOR51 16
#define NOR52 17
// Objeto normal que baja al pisarlo
#define NOR60 18
#define NOR61 19
#define NOR62 20
// Objeto normal que se mueve en x o y
#define NOR70 21
#define NOR71 22
#define NOR72 23
// Objeto normal que se mueve en z
#define NOR80 24
#define NOR81 25
#define NOR82 26
// Objeto normal que sube y baja al pisarlo
#define NOR90 27
#define NOR91 28
#define NOR92 29
// Objeto normal bajo puerta elevada ys
#define PTYS0 30
#define PTYS1 31
#define PTYS2 32
// Objeto normal bajo puerta elevada xi
#define PTXI0 33
#define PTXI1 34
#define PTXI2 35
// Objeto normal bajo puerta elevada yi
#define PTYI0 36
#define PTYI1 37
#define PTYI2 38
// Objeto normal bajo puerta elevada xs
#define PTXS0 39
#define PTXS1 40 
#define PTXS2 41
// Obstculos
#define OBS00 42 // Pirmide roja
#define OBS01 43 // Pirmide bronce
#define OBS02 44 // Pirmide oro
#define OBS03 45 // Cilindros cortados
#define OBS04 46 // Esfera rota
#define OBS05 47 // Mina voladora
#define OBS06 48 // Cscara
// Cerraduras
#define CERR0 49 // Cerradura cilindro
#define CERR1 50 // Cerradura cubo
#define CERR2 51 // Cerradura cono curvo
#define CERR3 52 // Cerradura pirmide
// Astronautas
#define ASTR0 53 // Astronauta que mira hacia la derecha
#define ASTR1 54 // Astronauta que mira hacia la izquierda
// Bloques "empujables"
#define MOV01 55 // Bloque "empujable" 0 anclable 
#define MOV10 56 // Bloque "empujable" 0 anclable
#define MOV11 57 // Bloque "empujable" 1 no anclable  
// Joystick controlador del telebot
#define JOYST 61
// Objetos animados
#define TLBOT 62 // Telebot
#define RBALA 63 // Robot aliengena de movimiento aleatorio
#define RBALX 64 // Robot aliengena de movimiento en el eje x
#define RBALY 65 // Robot aliengena de movimiento en el eje y
#define MINAT 66 // Mina terrestre
#define SATUR 67 // Saturno
#define RATAM 68 // Rata mecnica
#define PLAS0 69 // Plasma sin desplazamiento
#define PLAS1 70 // Plasma con desplazamiento x
#define PLAS2 71 // Plasma con desplazamiento y
#define PLAS3 72 // Plasma con desplazamiento xy
// Robots obsoletos y averiados
#define ROBS0 73 // Robot obsoleto negro
#define ROBS1 74 // Robot obsoleto blanco
#define ROBS2 75 // Robot obsoleto rojo
#define ROBS3 76 // Robot aliengena averiado
#define ROBS4 77 // Rata mecnica averiada
// Puerta misteriosa
#define PTCRR 79

//******************************************************************************
// Estructura para los objetos de las habitaciones.
//******************************************************************************
unsigned char mapa_obj[] = {
//   0
ELEV3, NOR01, COL02, ELEV4, NOR11, COL04, ELEV4, NOR61, COL07, ELEV5, NOR21,
COL77, NOR01, COL67, ELEV1, NOR01, COL57, ELEV2, NOR01, COL72, ELEV3, NOR51,
COL62, ELEV3, NOR51, COL30, ELEV3, NOR70,  0X31, PTXI1, PTYI1,
//   1
ASTR0, COL01, ASTR0, COL02, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL50, NOR11, COL40, OBS03, COL51, OBS03, COL61, NOR01, NOR01, CERR3, COL72, NOR11,
COL52, RBALA, COL42, OBS03, COL53, OBS03, COL63, OBS03, COL73, OBS03, 
//   2
COL12, NOR00, ELEV5, OBS04, COL22, NOR00, ELEV5, OBS04, COL04, NOR02, NOR02, OBS00,
COL14, NOR02, NOR02, OBS00, COL24, NOR02, NOR02, OBS00, COL34, NOR02, NOR02, OBS00,
COL16, NOR80,  0x03, COL26, ELEV3, NOR80,  0x03, 
//   3 (vaca)
//   4
CERR1, ELEV3, NOR01, OBS00, COL10, NOR01, COL20, ASTR1, COL30, ASTR1, COL40, ASTR1,
COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL01, NOR01, COL11, NOR01, COL02, ASTR0,
COL03, ASTR0, COL04, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
//   5
COL20, OBS01, COL21, OBS01, COL22, OBS01, COL12, OBS01, COL02, OBS01,
COL05, OBS02, COL15, OBS02, COL25, OBS02, COL26, OBS02, COL27, OBS02,
COL50, OBS00, COL51, OBS00, COL52, OBS00, COL53, OBS00,
COL54, OBS00, COL55, OBS00, COL56, OBS00, COL57, OBS00, 
//   6
COL33, NOR01, SATUR, COL43, NOR01, COL34, NOR01, COL44, NOR01, COL55, RATAM,
//   7
COL16, JOYST, COL34, TLBOT, COL30, MINAT, COL40, MINAT, COL50, MINAT, COL60, MINAT,
COL71, MINAT, COL41, MINAT, COL51, MINAT, COL61, MINAT, COL73, MINAT, COL53, MINAT,
COL63, MINAT, COL72, MINAT, COL42, MINAT, COL52, MINAT, COL62, MINAT, COL74, MINAT,
//   8
COL21, NOR01, COL51, NOR01, COL26, NOR01, COL56, NOR01, COL04, NOR01, NOR01, NOR01, OBS03,
COL24, NOR01, NOR01, NOR01, OBS03, COL54, NOR01, NOR01, NOR01, OBS03,
COL74, NOR01, NOR01, NOR01, OBS03, COL14, NOR01, NOR01, OBS03, COL64, NOR01, NOR01, OBS03,
COL34, OBS03, ELEV3, NOR82,  0x03, COL44, OBS03, NOR82,  0x03,
//   9
COL02, OBS04, OBS04, OBS04, NOR01, COL12, OBS04, OBS04, NOR11, COL22, OBS04, NOR11,
COL32, NOR11, COL05, ELEV3, NOR01, COL07, OBS04, ELEV2, NOR11, NOR11, PTXI1,
//  10
COL11, MOV01, MOV11, COL50, NOR01, OBS03, COL60, OBS04, COL70, NOR00, COL51, NOR01, OBS03,
COL61, OBS04, COL71, OBS04, COL52, NOR01, OBS03, COL62, NOR01, OBS03, COL72, NOR01, OBS03, 
//  11
COL32, NOR00, NOR50, COL42, NOR00, NOR50, COL23, NOR00, NOR50, COL24, NOR00, NOR50,
COL35, NOR00, NOR50, COL45, NOR00, NOR50, COL54, NOR00, NOR50, COL53, NOR00, NOR50,
COL33, ELEV2, NOR00, NOR50, COL43, ELEV2, NOR00, NOR50, COL34, ELEV2, NOR00, NOR50,
COL44, ELEV2, NOR00, NOR50, PTXI0,
//  12
OBS03, ELEV3, NOR01, COL10, OBS03, ELEV3, NOR11, COL20, ELEV3, NOR01, OBS03,
COL30, ELEV3, NOR61, COL40, ELEV3, NOR01, COL50, ELEV3, NOR01, OBS03, PTYI1,
COL60, ELEV3, NOR11, COL70, OBS03, ELEV3, NOR01, COL71, OBS03, ELEV3, NOR11,
COL72, ELEV3, NOR01, OBS03, COL07, NOR01, COL06, ELEV1, NOR61, COL05, ELEV2, NOR61,
COL04, ELEV3, NOR61, COL03, ELEV3, NOR11, COL02, ELEV3, NOR01, OBS03,
COL01, OBS03, ELEV3, NOR11,
//  13
COL11, MOV01, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL76, OBS04, OBS04, OBS04, COL67, OBS04, OBS04, OBS04, COL77, CERR0, ELEV3, NOR12,
//  14
COL13, OBS05, COL23, OBS05, COL04, OBS05, COL14, NOR00,
COL24, NOR00, COL34, OBS05, COL15, OBS05, COL25, OBS05,
//  15
COL30, NOR12, COL21, ELEV1, NOR12, COL02, OBS02, COL12, OBS02, ELEV2, NOR12, COL22, OBS02,
COL32, OBS02, COL03, OBS02, ELEV3, NOR12, COL13, OBS00, COL23, OBS00, COL33, OBS02,
COL04, OBS02, ELEV3, NOR12, COL14, OBS00, COL24, OBS00, COL34, OBS02, COL05, OBS02,
COL15, OBS02, ELEV2, NOR12, COL25, OBS02, COL35, OBS02, COL26, ELEV1, NOR12, COL37, NOR12,
//  16
ELEV3, NOR01, COL20, ELEV3, NOR01, COL50, ELEV4, NOR01, COL70, ELEV3, NOR61, PTYI1,
COL01, OBS04, ELEV3, NOR81,  0x03, COL06, OBS04, COL05, ELEV2, NOR61, COL03, ELEV4, NOR61,
//  17
ASTR0, COL01, ASTR0, COL02, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0, COL40, NOR01,
COL50, ELEV1, NOR01, COL60, ELEV2, NOR01, COL70, ELEV2, NOR01, COL72, ELEV2, OBS03,
COL71, ELEV2, OBS03, MOV01, MOV11, MOV01, MOV11, COL73, ELEV2, OBS03, COL74, ELEV2, OBS03,
COL77, NOR01, NOR01, NOR01, NOR01, CERR3,
//  18
COL32, ELEV1, NOR61, COL33, NOR11, NOR11, COL34, NOR11, NOR11, NOR11, NOR11,
COL35, NOR01, NOR01, OBS01, COL36, NOR01, NOR01, NOR01, OBS02, 
COL42, ELEV1, NOR61, COL43, NOR11, NOR11, COL44, NOR11, NOR11, NOR11, NOR11,
COL45, NOR01, NOR01, OBS01, COL46, NOR01, NOR01, NOR01, OBS02, PTXI1, PTCRR,
//  19
COL06, ASTR0, COL07, ASTR0, COL60, ASTR1, COL70, ASTR1, COL32, OBS03, COL42, OBS03,
COL23, OBS03, COL53, OBS03, COL24, OBS03, COL54, OBS03, COL35, OBS03, COL45, OBS03,
COL55, NOR00, NOR00, COL52, NOR00, NOR00, NOR00, COL22, NOR00, NOR00, NOR00, NOR00,
COL25, NOR00, NOR00, NOR00, NOR00, NOR00, CERR0,
//  20
COL77, NOR91,  0x04, RBALX, COL67, NOR91,  0x04, COL57, ELEV2, NOR91,  0x04, PTXI1,
//  21
NOR02, COL30, NOR02, COL06, NOR02, COL16, NOR02, COL26, NOR02, COL36, NOR02,
COL04, OBS04, NOR12, COL34, OBS04, NOR12, COL14, OBS04, COL24, OBS04,
COL13, OBS04, COL23, OBS04, COL33, PLAS0,
//  22 (vaca)
//  23
COL22, RATAM, COL21, OBS05, COL31, OBS05, COL41, OBS05, COL12, OBS05, COL13, OBS05,
COL14, OBS05, COL25, OBS05, COL35, OBS05, COL45, OBS05, COL52, OBS05, COL53, OBS05,
COL54, OBS05,
//  24
ASTR1, COL10, ASTR1, COL20, ASTR1, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1,
COL43, NOR01, NOR01, NOR11, COL34, NOR01, NOR01, NOR11, COL54, NOR01, NOR01, NOR11,
COL45, NOR01, NOR01, NOR11, COL44, NOR01, CERR1, ELEV3, MOV01,
//  25
COL60, ELEV2, NOR01, COL70, ELEV3, NOR61, COL61, ELEV3, NOR01, COL71, ELEV2, NOR01, RBALA,
COL62, ELEV3, NOR01, COL72, ELEV2, NOR01, COL63, ELEV3, NOR01, COL73, NOR01, NOR01, NOR01,
COL64, NOR00, OBS01, COL65, NOR00, OBS01, COL66, NOR00, OBS01, COL76, NOR00, OBS01, 
//  26
COL33, NOR92,  0x04, COL22, OBS04, COL23, OBS04, COL24, OBS04, COL34, OBS04, COL44, OBS04,
COL43, OBS04, COL42, OBS04, COL32, OBS04, COL63, ELEV3, NOR01, COL36, ELEV3, NOR01,
COL73, NOR01, NOR01, NOR01, COL74, NOR01, NOR01, NOR01, PTYI1,
COL37, NOR01, NOR01, NOR01, COL47, NOR01, NOR01, NOR01, PTXI1,
//  27
ASTR0, COL01, ASTR0, COL02, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL55, OBS03, COL75, OBS03, COL57, OBS03, COL77, OBS03, COL65, NOR01, NOR11,
COL56, NOR01, NOR11, COL76, NOR01, NOR11, COL67, NOR01, NOR11, COL66, ELEV2, NOR01, CERR2,
//  28
COL23, OBS04, ELEV2, NOR11, COL34, OBS04, ELEV2, NOR11, COL25, OBS04, ELEV2, NOR11,
COL14, OBS04, ELEV2, NOR61, COL24, NOR01, NOR01,
//  29
ASTR0, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL01, ASTR0, COL02, ASTR0, COL07, NOR02, NOR02,
COL06, ELEV2, NOR02, COL26, ELEV3, NOR22, COL36, ELEV3, NOR22,
COL46, ELEV3, NOR02, COL56, ELEV3, NOR02, MOV01, COL66, NOR02, NOR02, OBS03, ELEV3, NOR02,
COL76, ELEV2, OBS03, COL67, ELEV2, OBS03, COL57, NOR02, NOR02, OBS03, COL77, CERR1,
COL75, NOR02, NOR02, OBS03, COL65, ELEV3, NOR02, MOV01, COL16, ELEV3, NOR22, 
//  30
COL02, OBS05, COL12, OBS05, COL22, OBS05, COL32, OBS05,
COL05, OBS05, COL15, OBS05, COL25, OBS05, COL35, OBS05,
//  31
COL02, NOR01, OBS01, COL12, NOR01, OBS01, COL22, NOR01, OBS01, COL03, NOR01, OBS01,
COL34, NOR01, OBS01, COL15, NOR01, OBS01, COL25, NOR01, OBS01, COL35, NOR01, OBS01,
//  32
ASTR0, COL01, ASTR0, COL02, ASTR0, COL03, ASTR0, COL04, ASTR0, COL05, ASTR0, COL06, ASTR0,
COL07, ASTR0, COL55, MOV01, MOV11, MOV01, MOV11, MOV01, MOV11, ELEV6, NOR01,
COL65, ELEV6, NOR01, COL75, NOR01, NOR01, OBS03, ELEV6, NOR01, CERR0,
//  33
COL34, NOR02, COL43, NOR02, NOR02, COL52, NOR02, NOR02, NOR02, COL61, OBS03, ELEV3, NOR10,
COL71, OBS03, ELEV3, NOR10, COL60, OBS03, ELEV3, NOR10, COL70, NOR00, NOR00, NOR00, NOR00,
//  34 (vaca)
//  35
COL33, MOV01, COL34, MOV01, COL43, MOV01, COL44, MOV01, COL40, OBS04, COL51, OBS04,
COL61, OBS04, COL71, NOR01, NOR01, NOR01, COL50, PLAS2, ELEV3, NOR61, COL60, ELEV3, NOR01,
COL70, NOR01, ELEV3, NOR11,
//  36
ELEV3, NOR01, COL11, NOR01, COL30, ELEV3, NOR01, NOR01, COL40, ELEV3, NOR61,
COL60, ELEV3, NOR01, COL72, ELEV3, NOR01, COL07, RBALY, MOV10, ELEV3, NOR61,
COL05, ELEV3, NOR01, COL04, ELEV3, NOR11, PTXI1, PTYI1,
//  37 (vaca)
//  38
COL05, ASTR0, COL06, ASTR0, COL07, ASTR0, COL43, NOR01, ELEV7, OBS06, COL34, NOR01, ELEV7, OBS06,
COL54, NOR01, ELEV7, OBS06,  COL45, NOR01, ELEV7, OBS06, COL44, NOR01, NOR01, NOR01, CERR2,
//  39 (vaca)
//  40
COL40, NOR01, NOR01, NOR01, OBS01, COL52, OBS00, COL53, OBS00, COL32, OBS00, COL33, OBS00,
COL43, NOR01, NOR01, NOR01, OBS01, COL30, OBS00, COL31, OBS00, COL50, OBS00, COL51, OBS00,
COL42, OBS04, ELEV3, NOR81,  0x03, COL41, OBS04, ELEV3, NOR81,  0x03,
//  41
COL31, NOR02, COL41, NOR02, COL32, NOR12, NOR12, COL42, NOR12, NOR12, COL13, NOR02,
COL23, NOR12, NOR12, COL33, ELEV2, NOR12, COL43, OBS04, ELEV2, NOR12, COL53, NOR12, NOR12,
COL63, NOR02, COL14, NOR02, COL24, NOR12, NOR12, COL34, OBS04, ELEV2, NOR12,
COL44, OBS04, ELEV2, NOR12, COL54, NOR12, NOR12, COL64, NOR02, COL35, NOR12, NOR12,
COL45, NOR12, NOR12, COL36, NOR02, COL46, NOR02,
//  42
COL02, OBS04, COL12, OBS04, COL22, OBS04, COL21, OBS04, COL20, OBS04,
COL05, OBS04, COL15, OBS04, COL25, OBS04, COL26, OBS04, COL27, OBS04,
COL57, OBS04, COL56, OBS04, COL55, OBS04, COL65, OBS04, COL75, OBS04,
COL50, OBS04, COL51, OBS04, COL52, OBS04, COL62, OBS04, COL72, OBS04,
//  43
COL22, RBALA,
//  44
COL20, OBS04, COL21, OBS04, COL22, OBS04, COL23, OBS04, COL30, RBALA,
COL50, OBS04, COL51, OBS04, COL52, OBS04, COL53, OBS04,
//  45
COL16, JOYST, COL66, TLBOT, COL20, MINAT, MINAT, COL50, MINAT, MINAT,
COL21, MINAT, MINAT, COL51, MINAT, MINAT, COL32, MINAT, MINAT, COL42, MINAT, MINAT,
//  46
COL70, ASTR1, COL60, ASTR1, COL50, ASTR1, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL26, MOV01, MOV11, COL66, NOR00, NOR00, NOR00, NOR00, NOR00, CERR3,
COL76, ELEV4, NOR00, COL67, ELEV4, NOR00,
//  47
NOR01, COL10, NOR01, NOR01, COL20, NOR01, NOR01, NOR01, COL30, OBS03, COL40, OBS03,
COL50, OBS03, COL60, OBS03, COL70, ELEV1, NOR00, CERR2, COL51, OBS03, COL61, OBS03,
COL71, OBS03, COL52, OBS03, COL62, OBS03, COL72, OBS03, COL73, OBS03, COL74, OBS03,
COL75, NOR01, NOR01, NOR01, COL76, NOR01, NOR01, COL77, NOR01, COL05, ASTR0,
COL06, ASTR0, COL07, ASTR0,
//  48
COL01, MINAT, COL11, MINAT, COL21, MINAT, COL51, MINAT, COL61, MINAT, COL71, MINAT,
COL02, MINAT, COL12, MINAT, COL22, MINAT, COL52, MINAT, COL62, MINAT, COL72, MINAT,
COL05, MINAT, COL15, MINAT, COL25, MINAT, COL55, MINAT, COL65, MINAT, COL75, MINAT,
COL06, MINAT, COL16, MINAT, COL26, MINAT, COL56, MINAT, COL66, MINAT, COL76, MINAT,
COL33, MINAT, COL34, MINAT, COL43, MINAT, COL44, MINAT, COL04, RATAM, COL73, RATAM, 
//  49
NOR02, TLBOT, COL01, NOR02, COL02, NOR02, COL12, NOR02, COL22, NOR02, COL21, NOR02,
COL31, NOR02, COL41, NOR02, COL42, NOR02, COL43, NOR02, COL44, NOR02, COL16, JOYST,
COL53, NOR00, MINAT, COL54, NOR00, MINAT, COL62, NOR00, MINAT, COL63, NOR00, MINAT,
COL64, NOR00, MINAT, COL65, NOR00, MINAT, COL75, NOR00, MINAT, COL72, NOR00, MINAT,
//  50
COL32, NOR01, NOR01, NOR01, NOR01, NOR01, COL42, NOR01, NOR01, NOR01, NOR01, NOR01,
COL23, NOR01, NOR01, NOR01, COL53, NOR01, NOR01, NOR01, COL34, NOR01, NOR01,
COL44, NOR01, NOR01, COL33, OBS04, ELEV2, NOR11, COL43, OBS04, ELEV2, NOR11,
//  51
COL20, OBS04, NOR42, COL30, OBS04, NOR42, COL40, OBS04, NOR42, COL50, OBS04, NOR42,
COL23, OBS04, NOR52, COL33, OBS04, NOR52, COL43, OBS04, NOR52, COL53, OBS04, NOR52,
COL21, OBS04, COL31, OBS04, COL41, OBS04, COL51, OBS04, COL22, OBS04, COL32, OBS04,
COL42, OBS04, COL52, OBS04,
//  52
NOR01, OBS04, COL70, NOR01, OBS04, COL07, NOR01, OBS04, COL77, NOR01, OBS04,
COL12, NOR00, OBS02, COL21, NOR00, OBS02, COL51, NOR00, OBS02, COL62, NOR00, OBS02,
COL15, NOR00, OBS02, COL26, NOR00, OBS02, COL56, NOR00, OBS02, COL65, NOR00, OBS02,
COL33, NOR02, OBS00, COL43, NOR02, OBS00, COL34, NOR02, OBS00, COL44, NOR02, OBS00, 
//  53
NOR00, NOR00, COL77, NOR00, NOR00, COL07, NOR00, NOR00, OBS00, COL70, NOR00, NOR00, OBS00,
COL34, NOR02, COL44, NOR02, COL43, NOR02, COL33, NOR02, PLAS3,
//  54 (vaca)
//  55
COL30, ASTR1, COL40, ASTR1, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL05, ASTR0,
COL06, ASTR0, COL07, ASTR0, COL43, NOR01, COL34, NOR01, COL54, NOR01, COL45, NOR01,
COL44, NOR01, MOV01, MOV11, ELEV3, NOR01, CERR0,
//  56
COL73, NOR01, NOR01, NOR01, COL64, NOR01, NOR01, NOR01, COL65, NOR01, NOR01, NOR01,
COL66, OBS03, COL76, NOR01, NOR01, NOR11, COL75, ELEV1, NOR11, COL74, ELEV1, NOR11, RBALY,
//  57
COL20, OBS02, COL50, OBS02, COL61, OBS02, COL21, OBS02, COL32, OBS02,
COL42, OBS02, COL53, OBS02, COL63, OBS02, COL75, OBS02, COL07, OBS02,
COL27, OBS02, COL57, OBS02, COL56, OBS02, COL55, OBS02, COL45, OBS02,
COL34, OBS02, COL24, OBS02, COL14, OBS02, COL13, OBS02, COL15, OBS02,
//  58
COL61, MOV01, MOV11, MOV01, MOV11, ELEV4, NOR00, COL76, OBS03, COL77, OBS03, COL67, OBS03,
COL65, NOR01, NOR01, NOR01, NOR01, ELEV5, OBS02, COL64, ELEV4, NOR70,  0x65,
COL13, NOR01, NOR01, NOR01, NOR01, NOR70,  0x23, ELEV5, OBS02, PTXI1,
//  59
COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL16, NOR00, MOV01, MOV11, COL33, NOR00, OBS03,
COL43, NOR00, OBS03, COL53, NOR00, OBS03, COL34, NOR00, OBS03, COL54, NOR00, OBS03,
COL35, NOR00, OBS03, COL45, NOR00, OBS03, COL55, NOR00, OBS03,
COL44, NOR00, OBS03, ELEV2, NOR00, NOR00, CERR1,
//  60
COL01, NOR01, COL02, NOR01, NOR01, NOR01, COL03, NOR01, NOR01, NOR01, NOR01, NOR01,
COL04, OBS04, ELEV2, NOR01, ELEV5, NOR01, COL05, ELEV2, NOR01, ELEV5, NOR11,
COL06, OBS04, ELEV2, NOR11, ELEV5, NOR01, COL07, ELEV2, NOR11, NOR11, NOR11, NOR11,
COL14, ELEV3, NOR00, NOR00, COL15, ELEV3, NOR00, NOR00, COL16, ELEV3, NOR00, NOR00,
//  61
ELEV2, CERR3, COL10, ELEV1, NOR01, NOR01, COL20, NOR01, ASTR0, COL01, ELEV1, NOR01, NOR01,
COL11, ELEV1, NOR01, NOR01, COL21, NOR01, ASTR0, COL12, NOR01, ASTR1, COL02, NOR01, ASTR1,
COL22, NOR01, COL27, NOR01, COL17, ELEV1, NOR01, COL07, ELEV2, NOR01, COL06, ELEV3, NOR01,
COL72, NOR01, COL71, ELEV1, NOR01, COL70, ELEV2, NOR01, COL60, ELEV3, NOR01,
//  62
COL02, NOR00, OBS03, COL05, NOR00, OBS03, COL32, NOR00, OBS03, COL35, NOR00, OBS03,
COL03, RBALA,
//  63 (vaca)
//  64
COL10, MINAT, COL20, MINAT, COL50, MINAT, COL60, MINAT, COL11, MINAT, COL21, MINAT,
COL51, MINAT, COL61, MINAT, COL22, MINAT, COL32, MINAT, COL42, MINAT, COL52, MINAT,
COL33, MINAT, COL43, MINAT, COL66, TLBOT, COL16, NOR02, NOR02, COL05, NOR02, NOR02,
COL14, NOR02, NOR02, COL25, NOR02, NOR02, COL15, NOR00, NOR00, JOYST,
//  65
COL16, JOYST, COL20, NOR00, OBS01, COL21, NOR00, OBS01, COL31, NOR00, OBS01,
COL41, NOR00, OBS01, COL51, NOR00, OBS01, COL50, NOR00, OBS01, COL77, TLBOT, MOV01,
COL70, NOR00, NOR00, NOR00, NOR00, 
//  66 (vaca)
//  67
ASTR0, COL02, ASTR0, COL05, ASTR0, COL07, ASTR0, COL10, OBS03, COL20, OBS03, COL30, OBS03,
COL40, ELEV3, NOR01, CERR1, COL50, OBS03, COL60, OBS03, COL70, OBS03, COL31, OBS03,
COL51, OBS03, COL32, OBS03, COL52, OBS03, COL33, OBS03, COL53, OBS03, COL34, OBS03,
COL54, OBS03, COL41, ELEV2, NOR11, COL42, ELEV2, NOR11, COL43, ELEV2, NOR11,
COL44, ELEV2, NOR11, COL45, NOR01, NOR01, NOR01, NOR01, COL55, NOR01, NOR01,
//  68 (vaca)
//  69
NOR02, OBS00, COL30, NOR02, OBS00, COL11, NOR02, OBS00, COL07, NOR02, OBS00,
COL37, NOR02, OBS00, COL16, NOR02, OBS00, COL21, NOR42, COL26, NOR52, COL22, OBS04,
COL25, OBS04, COL24, OBS04, NOR80,  0x03, COL23, OBS04, ELEV3, NOR80,  0x03,
//  70
MINAT, COL10, MINAT, COL20, MINAT, ELEV1, NOR00, OBS00, COL50, MINAT, ELEV1, NOR00, OBS00,
COL60, MINAT, COL70, MINAT, COL11, MINAT, COL21, MINAT, COL31, MINAT, COL41, MINAT,
COL51, MINAT, COL61, MINAT, COL22, MINAT, COL32, MINAT, COL42, MINAT, COL52, MINAT,
COL33, MINAT, COL43, MINAT, COL66, JOYST, COL16, TLBOT,
//  71
COL01, OBS04, COL11, NOR02, COL21, NOR02, COL31, OBS04, COL14, PLAS1,
COL06, OBS04, COL16, NOR02, COL26, NOR02, COL36, OBS04,
//  72
COL02, NOR01, ELEV4, OBS06, COL12, NOR01, ELEV4, OBS06, COL22, NOR01, ELEV4, OBS06,
COL32, NOR01, ELEV4, OBS06, COL03, NOR01, ELEV4, OBS06, COL13, NOR01, ELEV4, OBS06,
COL23, NOR01, ELEV4, OBS06, COL33, NOR01, ELEV4, OBS06, COL04, NOR01, ELEV4, OBS06,
COL14, NOR01, ELEV4, OBS06, COL24, NOR01, ELEV4, OBS06, COL34, NOR01, ELEV4, OBS06, 
COL05, NOR01, ELEV4, OBS06, COL15, NOR01, ELEV4, OBS06, COL25, NOR01, ELEV4, OBS06,
COL35, NOR01, ELEV4, OBS06, 
//  73
COL43, OBS04, COL34, OBS04, COL54, OBS04, COL45, OBS04,
COL44, OBS04, NOR11, NOR11, NOR11, NOR11, COL77, NOR01, COL67, ELEV1, NOR01,
COL57, ELEV2, NOR01, PTXI1,
//  74
COL02, NOR42, COL12, NOR42, COL22, NOR42, COL32, NOR42, COL03, OBS04, COL13, OBS04,
COL23, OBS04, COL33, OBS04, COL04, OBS04, COL14, OBS04, COL24, OBS04, COL34, OBS04,
COL05, NOR52, COL15, NOR52, COL25, NOR52, COL35, NOR52,
//  75
COL23, SATUR,
//  76
ELEV3, NOR21, COL10, ELEV3, NOR21, COL20, ELEV3, NOR21, COL30, OBS04, ELEV3, NOR11,
COL40, ELEV3, NOR11, COL50, OBS04, COL60, OBS04, COL70, OBS04, ELEV3, NOR01,
COL01, ELEV2, NOR01, COL02, ELEV1, NOR01, COL03, NOR01, PTYI1,
//  77
COL05, ASTR0, COL06, ASTR0, COL07, ASTR0, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1,
COL77, OBS03, COL76, OBS03, COL52, MOV01, MOV11, COL25, MOV01, MOV11, MOV01, MOV11,
COL33, NOR01, NOR01, NOR01, NOR01, NOR01, CERR1, COL67, OBS03,
//  78
COL20, NOR01, OBS03, COL21, ELEV1, OBS03, COL22, ELEV1, OBS03, COL23, NOR01, OBS03,
COL50, NOR01, OBS03, COL51, ELEV1, OBS03, COL52, ELEV1, OBS03, COL53, NOR01, OBS03,
COL31, RATAM,
//  79
COL23, NOR01, OBS00, COL32, NOR91,  0x04, COL33, NOR01, NOR01, NOR01,
COL34, OBS00, ELEV3, NOR31, COL35, OBS00, ELEV3, NOR31, COL36, OBS00, ELEV3, NOR11, 
COL53, NOR01, OBS00, COL42, NOR91,  0x04, COL43, NOR01, NOR01, NOR01,
COL44, OBS00, ELEV3, NOR21, COL45, OBS00, ELEV3, NOR21, COL46, OBS00, ELEV3, NOR11, PTXI1,
//  80
COL24, JOYST, NOR01, NOR01, TLBOT, ELEV4, NOR01, COL25, NOR11, NOR11, NOR11,
COL23, NOR11, NOR11, NOR11, COL14, NOR11, NOR11, NOR11, COL34, NOR11, NOR11, NOR11,
COL62, MINAT, COL72, MINAT, COL53, MINAT, COL54, MINAT, COL65, MINAT, COL75, MINAT,
COL66, MOV01,
//  81
COL20, NOR01, OBS00, COL21, OBS01, COL23, NOR01, OBS00, COL22, OBS01, COL31, RATAM,
COL50, NOR01, OBS00, COL51, OBS01, COL53, NOR01, OBS00, COL52, OBS01,
COL30, ELEV2, NOR11, COL40, ELEV2, NOR11,
//  82
COL72, NOR01, OBS02, COL73, NOR01, NOR01, NOR01, NOR01, COL74, NOR01, NOR01, NOR01, NOR01,
COL75, NOR01, OBS02, COL62, NOR01, OBS02, COL65, NOR01, OBS02, COL53, NOR01, OBS02,
COL54, NOR01, OBS02, COL63, NOR10, COL64, NOR10,
//  83 (vaca)                                                                            
//  84
NOR00, COL01, NOR00, NOR00, COL02, OBS00, ELEV2, NOR20, COL03, OBS00, ELEV2, NOR10,
COL04, OBS00, ELEV2, NOR10, COL05, OBS00, ELEV2, NOR20, COL06, NOR00, NOR00, COL07, NOR00,
COL12, OBS00, COL22, OBS00, COL32, OBS00, COL33, OBS00, COL34, OBS00, COL15, OBS00,
COL25, OBS00, COL35, OBS00, COL13, OBS02, COL23, OBS02, COL14, OBS02, COL24, OBS02,
//  85
COL53, MOV01, MOV01, PTYI1,
//  86
COL11, NOR21, COL21, NOR21, COL12, NOR21, COL22, NOR21, COL31, OBS04, COL32, OBS04,
COL41, NOR21, COL51, NOR21, COL42, NOR21, COL52, NOR21, COL61, OBS04, ELEV3, NOR81,  0x03,
COL62, OBS04, NOR81,  0x03, PTYI1,
//  87
ASTR0, COL01, ASTR0, COL02, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL70, NOR01, NOR01, NOR01, NOR01, CERR2, COL71, NOR01, NOR01, NOR01, OBS03, 
COL72, NOR01, NOR01, NOR01, OBS03, COL73, NOR01, NOR01, OBS03, COL74, NOR01, OBS03,
COL75, OBS03, COL76, MOV01, MOV11, MOV01, MOV11, MOV01,
//  88
ELEV3, NOR01, COL10, ELEV3, NOR11, COL20, OBS04, ELEV3, NOR11, COL30, ELEV1, NOR11,
COL40, ELEV1, NOR11, COL50, OBS04, ELEV3, NOR11, COL60, ELEV4, NOR11, COL70, ELEV5, NOR01,
COL71, ELEV4, NOR11, COL72, ELEV3, NOR11, COL01, ELEV3, NOR11, COL02, OBS04, ELEV3, NOR11,
COL03, OBS04, ELEV3, NOR11, COL04, OBS04, ELEV3, NOR11, COL07, ELEV3, NOR01, PTYI1,
COL31, OBS04, COL41, OBS04, PTXI1,
//  89
COL31, RATAM, COL42, RATAM,
//  90
COL02, NOR01, COL12, NOR01, COL22, NOR01, COL21, NOR01, COL20, NOR01,
COL05, NOR01, COL15, NOR01, COL25, NOR01, COL26, NOR01, COL27, NOR01,
COL57, NOR01, COL56, NOR01, COL55, NOR01, COL65, NOR01, COL75, NOR01,
COL50, NOR01, COL51, NOR01, COL52, NOR01, COL62, NOR01, COL72, NOR01,
//  91
ASTR0, COL01, ASTR0, COL02, ASTR0, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL70, ELEV3, NOR01, CERR3, COL71, OBS04, ELEV3, NOR71,  0x72, COL72, OBS04,
COL76, ELEV3, NOR71,  0x75, COL77, NOR01, NOR01, NOR01, NOR01,
COL67, NOR01, NOR01, NOR01, COL57, NOR01, NOR01,
//  92
ELEV3, NOR01, COL01, ELEV3, NOR70,  0x02, COL03, NOR01, NOR01, OBS01,
COL04, NOR01, NOR01, OBS01, COL06, ELEV3, NOR70,  0x05, COL07, NOR01, NOR01,
//  93
ASTR1, COL10, ASTR1, COL20, ASTR1, COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL33, OBS03,
COL43, OBS03, NOR10, COL53, OBS03, COL34, OBS03, NOR10, COL44, NOR00, NOR00, NOR00, CERR2,
COL54, OBS03, NOR10, COL35, OBS03, COL45, OBS03, NOR10, COL55, OBS03,
//  94
COL04, NOR02, NOR02, NOR02, OBS01, COL14, NOR02, OBS00,
COL34, NOR02, NOR02, NOR02, OBS02, COL24, NOR02, OBS00,
//  95
NOR01, NOR01, NOR01, OBS00, COL01, ELEV4, OBS00, COL02, NOR91,  0x05, ELEV5, OBS00,
COL03, NOR01, NOR91,  0x05, ELEV6, OBS00, COL04, NOR01, NOR01, NOR91,  0x05, ELEV7, OBS00,
COL05, NOR01, NOR01, NOR01, NOR91,  0x05, COL06, NOR01, NOR01, COL11, NOR01, OBS00,
COL12, NOR01, OBS00,
//  96
COL04, NOR01, OBS02, COL14, NOR01, OBS02, COL50, NOR01, OBS02, COL51, NOR01, OBS02,
COL53, NOR01, OBS02, COL54, NOR01, NOR01, OBS02, COL24, NOR01, NOR01, OBS02, 
COL34, OBS03, NOR80,  0x03, COL44, OBS03, ELEV3, NOR80,  0x03, COL52, NOR01, OBS02, 
//  97
COL67, NOR01, NOR01, OBS03, COL77, OBS03, COL66, NOR01, OBS03, COL76, NOR01,
ELEV4, NOR01, MOV11, COL65, OBS03, COL75, OBS03, ELEV3, NOR01, COL74, ELEV2, NOR01,
COL73, ELEV1, NOR01, COL72, NOR01,
//  98
NOR01, OBS00, COL27, NOR00, OBS01, COL36, NOR00, OBS01, COL25, NOR00, OBS01,
COL14, NOR00, OBS01, COL57, NOR02, OBS02, COL56, NOR02, OBS02, COL55, NOR02, OBS02,
COL44, NOR02, OBS02, COL33, NOR02, OBS02, COL22, NOR02, OBS02, COL21, NOR02, OBS02,
//  99
COL74, NOR01, COL75, ELEV1, NOR01, COL76, ELEV2, NOR01,
COL47, NOR01, COL57, ELEV1, NOR01, COL67, ELEV2, NOR01,
COL77, NOR01, OBS04, ELEV7, NOR81,  0X07,
// 100
COL12, NOR01, COL22, NOR01,
COL13, NOR01, NOR01, NOR01, NOR01, COL23, NOR01, NOR01, NOR01, NOR01,
COL04, OBS00, COL14, ELEV3, NOR11, COL24, ELEV3, NOR11, COL34, OBS00,
COL05, OBS00, COL15, ELEV3, NOR31, COL25, ELEV3, NOR21, COL35, OBS00,
COL06, OBS00, COL16, ELEV3, NOR31, COL26, ELEV3, NOR21, COL36, OBS00,
COL07, OBS00, COL17, ELEV3, NOR31, COL27, ELEV3, NOR21, COL37, OBS00, PTXI1,
// 101
COL13, PLAS3, COL12, NOR70,  0x22, COL25, NOR70,  0x15,
// 102
COL33, OBS04, ELEV1, NOR10, NOR10, NOR10, NOR10, NOR10, NOR10,
COL43, OBS04, ELEV1, NOR10, NOR10, NOR10, NOR10, NOR10, COL53, OBS04, ELEV1, NOR10,
NOR10, NOR10, NOR10, COL54, OBS04, ELEV1, NOR10, NOR10, NOR10, COL55, OBS04, ELEV1,
NOR10, NOR10, COL45, OBS04, ELEV1, NOR10, COL35, OBS04, COL34, OBS04,
// 103
COL57, NOR01, COL56, ELEV1, NOR01, COL55, ELEV2, NOR01, COL54, ELEV3, NOR01, NOR11,
COL44, ELEV3, NOR01, COL33, ELEV3, NOR01, RATAM, COL34, ELEV3, NOR01, COL43, ELEV3, NOR01,
COL32, ELEV4, NOR11, COL42, ELEV4, NOR11, COL35, ELEV4, NOR11, COL45, ELEV4, NOR11,
COL23, ELEV4, NOR11, COL24, ELEV4, NOR11, COL53, ELEV4, NOR11, PTXI1,
// 104
COL07, NOR02, PLAS0, COL77, NOR02, COL24, NOR01, NOR01, NOR01, NOR01,
COL54, NOR01, NOR01, NOR01, NOR01, COL34, OBS04, ELEV3, NOR11, COL44, OBS04, ELEV3, NOR11, 
// 105
COL02, NOR91,  0x04, COL12, NOR41, COL22, NOR41, COL32, NOR41,
COL03, NOR01, OBS02, COL13, NOR01, OBS02, COL23, NOR01, OBS02, COL33, NOR01, OBS02,
COL04, NOR01, OBS02, COL14, NOR01, OBS02, COL24, NOR01, OBS02, COL34, NOR01, OBS02,
COL05, NOR91,  0x04, COL15, NOR51, COL25, NOR51, COL35, NOR51,
// 106
COL06, OBS00, COL15, OBS00, COL25, OBS00, COL34, OBS00,
COL31, OBS01, COL22, OBS01, COL12, OBS01, COL03, OBS01,
// 107
COL02, NOR12, NOR12, NOR12, NOR12, NOR12, NOR12, COL03, ELEV2, NOR12,
COL13, NOR02, NOR02, OBS04, COL04, NOR02, NOR02, OBS04, NOR12,
COL05, NOR02, NOR02, NOR02, COL06, NOR02, NOR02, COL07, NOR02,
// 108
COL11, MOV01, COL06, ASTR0, COL07, ASTR0, COL67, NOR01, NOR01, NOR01, NOR01,
COL77, NOR01, NOR01, NOR01, NOR01, COL54, NOR01, NOR01, NOR01, NOR01,
COL64, NOR01, NOR01, NOR01, NOR01, COL74, NOR01, NOR01, NOR01, NOR01,
COL55, ELEV3, NOR01, COL65, ELEV4, NOR00, COL75, CERR0, ELEV4, NOR00,
COL66, ELEV4, NOR00, COL76, ELEV4, NOR00,
// 109 (vaca)
// 110 (vaca)
// 111
COL02, NOR00, OBS00, COL72, NOR00, OBS00, COL06, NOR00, OBS00, COL76, NOR00, OBS00,
COL04, ELEV2, NOR11, COL14, ELEV2, NOR11, COL24, NOR01, NOR01, NOR01,
COL74, ELEV2, NOR11, COL64, ELEV2, NOR11, COL54, NOR01, NOR01, NOR01,
COL34, NOR02, OBS00, COL44, NOR02, OBS00, COL05, RBALA,
// 112
ELEV2, NOR62, COL10, ELEV1, NOR62, COL20, NOR02, COL01, ELEV3, NOR42,
COL02, ELEV3, NOR42, COL03, ELEV3, NOR42, COL04, ELEV3, NOR42, COL05, ELEV3, NOR42,
COL07, OBS04, ELEV4, NOR10, NOR10, PTXI2,
// 113
COL02, OBS03, COL12, OBS03, COL22, OBS03, COL21, OBS03, COL20, OBS03,
COL05, OBS03, COL15, OBS03, COL25, OBS03, COL26, OBS03, COL27, OBS03,
COL57, OBS03, COL56, OBS03, COL55, OBS03, COL65, OBS03, COL75, OBS03,
COL50, OBS03, COL51, OBS03, COL52, OBS03, COL62, OBS03, COL72, OBS03,
// 114
COL02, NOR02, OBS00, COL12, NOR02, OBS00, COL13, NOR02, OBS00, COL14, NOR02, OBS00,
COL05, NOR02, OBS00, COL15, NOR02, OBS00, COL62, NOR02, OBS01, COL72, NOR02, OBS01,
COL63, NOR02, OBS01, COL64, NOR02, OBS01, COL65, NOR02, OBS01, COL75, NOR02, OBS01,
// 115
COL40, NOR12, COL41, ELEV1, NOR12, COL42, OBS04, ELEV2, NOR12, COL13, NOR12, COL23, ELEV1, NOR12,
COL33, OBS04, ELEV2, NOR12, COL43, OBS04, ELEV3, NOR12, COL53, OBS04, ELEV2, NOR12, COL63,
ELEV1, NOR12, COL73, NOR12, COL44, OBS04, ELEV2, NOR12, COL45, ELEV1, NOR12, COL46, NOR12,
// 116
COL33, OBS04, COL43, OBS04, COL53, ELEV1, NOR32, COL63, ELEV2, NOR32,
COL34, OBS04, COL44, OBS04, COL54, ELEV1, NOR32, COL64, ELEV2, NOR32,
COL35, ELEV1, NOR52, COL45, ELEV1, NOR52, COL36, ELEV2, NOR52, COL46, ELEV2, NOR52,
COL73, ELEV3, NOR32, COL74, ELEV3, NOR32, COL37, ELEV3, NOR52, COL47, ELEV3, NOR52, PTXI2, PTYI2,
// 117
COL55, OBS03, ELEV1, NOR12, NOR12, COL45, OBS03, ELEV2, NOR12, NOR12,
COL44, OBS03, ELEV3, NOR12, NOR12, COL54, OBS03, ELEV4, NOR12, NOR12,
// 118
COL33, NOR02, NOR02, COL35, NOR02, NOR02, COL53, NOR02, NOR02, COL55, NOR02, NOR02,
COL43, ELEV2, NOR02, NOR02, COL34, ELEV2, NOR02, NOR02, COL54, ELEV2, NOR02, NOR02,
COL45, ELEV2, NOR02, NOR02, COL44, MOV01, MOV11, ELEV3, OBS06,
// 119
ELEV3, NOR82,  0x03, COL10, OBS04, ELEV3, NOR40, COL20, ELEV3, NOR40,
COL30, ELEV3, NOR40, COL40, ELEV3, NOR40, COL50, ELEV3, NOR40, COL60,
ELEV3, OBS04, COL70, ELEV3, NOR00, CERR2, COL71, ELEV3, OBS04, COL72, ELEV3, NOR40,
COL73, ELEV3, NOR40, COL74, ELEV3, NOR40, COL75, ELEV3, NOR40,
COL76, NOR00, OBS04, ELEV3, NOR40, COL66, NOR00, OBS04, COL67, NOR00, OBS04,
COL01, OBS04, COL11, OBS04, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
// 120
NOR02, NOR02, COL07, NOR02, NOR02, PTYI2,
COL01, ELEV2, NOR02, COL02, ELEV3, NOR02, COL06, ELEV2, NOR02, COL05, ELEV3, NOR02,
COL03, ELEV4, NOR02, COL13, ELEV4, NOR02, COL23, ELEV4, NOR12, COL33, ELEV4, NOR12,
COL04, ELEV4, NOR02, COL14, ELEV4, NOR02, COL24, ELEV4, NOR12, COL34, ELEV4, NOR12,
// 121
COL23, OBS04, COL33, OBS04, COL43, NOR32, COL53, ELEV1, NOR32, COL63, ELEV2, NOR32,
COL24, OBS04, COL34, OBS04, COL44, NOR32, COL54, ELEV1, NOR32, COL64, ELEV2, NOR32,
COL73, ELEV3, NOR32, COL74, ELEV3, NOR32, PTYI2,
// 122
COL23, OBS03, COL33, NOR02, OBS01, COL43, OBS03, COL24, NOR02, OBS01, COL34, OBS04,
COL44, NOR02, OBS01, COL25, OBS03, COL35, NOR02, OBS01, COL45, OBS03,
// 123
COL23, NOR02, COL33, ELEV1, NOR02, COL43, NOR02, COL24, ELEV1, NOR02,
COL34, ELEV2, NOR02, NOR02, NOR02, NOR02, NOR02, COL44, ELEV1, NOR02,
ELEV4, NOR02, COL25, NOR02, COL35, ELEV1, NOR02, COL45, NOR02,
// 124
ASTR1, COL10, ASTR1, COL20, ASTR1, COL50, ASTR1, COL60, ASTR1,
COL70, ASTR1, COL43, NOR02, COL33, NOR02, MOV01, MOV11, COL34, NOR02,
COL44, NOR02, COL07, NOR02, NOR02, NOR02, NOR02, NOR02, CERR3,
// 125
COL11, TLBOT, COL50, OBS03, COL60, OBS03, COL70, OBS03, ELEV2, OBS03, COL51, OBS03,
COL61, OBS03, TLBOT, COL71, OBS03, COL52, OBS03, COL62, OBS03, COL72, OBS03, COL16, JOYST,
// 126
COL50, ASTR1, COL60, ASTR1, COL70, ASTR1, COL05, ASTR0, COL06, ASTR0, COL07, ASTR0,
COL33, ELEV1, OBS03, COL53, ELEV1, OBS03, COL35, ELEV1, OBS03, COL55, ELEV1, OBS03,
COL43, NOR02, NOR02, ELEV6, OBS06, COL45, NOR02, NOR02, ELEV6, OBS06,
COL54, NOR02, NOR02, ELEV6, OBS06, COL34, NOR02, NOR02, ELEV6, OBS06, COL44, CERR0,
// 127
COL22, NOR40, COL32, NOR30, COL42, NOR30, COL52, NOR30, COL23, NOR20, COL24, NOR40,
COL25, NOR20, COL35, NOR20, COL45, NOR20, COL55, NOR50, COL54, NOR50, COL53, NOR50,
COL34, ELEV1, NOR00, COL44, ELEV2, NOR00, COL43, ELEV3, NOR00, COL33, OBS04, ELEV4, NOR00,
// Reprogramando
COL11, NOR01, COL21, NOR01, COL31, NOR01, COL41, NOR01, COL51, NOR01,
COL71, NOR01, NOR01, NOR01, COL50, NOR01, NOR01, NOR01, OBS04, COL60, NOR01, NOR01, NOR01,
NOR01, NOR01, NOR01, OBS01, COL70, NOR01, NOR01, NOR01, OBS04, COL52, NOR01, NOR01, NOR01, OBS04,
COL62, NOR01, COL72, NOR01, NOR01, NOR01, OBS04, COL63, NOR01, COL64, NOR01,
COL65, NOR01, COL40, NOR01, NOR10, NOR10, COL73, NOR01, NOR10, NOR10,
COL61, NOR01, ELEV4, NOR12, NOR12, COL02, ROBS2, COL03, ROBS2, COL04, ROBS1,
COL05, ROBS1, COL06, ROBS0, COL07, ROBS0, COL23, ROBS3, COL33, ROBS4, COL43, ROBS4,
COL46, NOR03, COL47, NOR03, COL36, NOR03, COL37, NOR03, NOR03
};
 
//******************************************************************************
// Estructura para las llaves.
//******************************************************************************
#define NUM_LLAVES 36
struct{
 char tipo;          // Tipo de objeto
 unsigned char xiyi; // Coordenadas x e y iniciales (+ desplazamiento)
 unsigned char zi;   // Coordenada z inicial
 char habi,hab;      // Habitaciones inicial y actual
 int x,y,z;
} llave[NUM_LLAVES]={{0,0xb0,0, 70,0,0,0,0},{0,0x94,1, 14,0,0,0,0},{0,0x77,2, 99,0,0,0,0},
                     {0,0x70,4, 33,0,0,0,0},{0,0x04,3, 60,0,0,0,0},{0,0x54,6,117,0,0,0,0},
                     {0,0x75,0, 56,0,0,0,0},{0,0x74,3,111,0,0,0,0},{0,0x34,7,123,0,0,0,0},
                     {1,0x9b,1, 72,0,0,0,0},{1,0x70,1, 10,0,0,0,0},{1,0x33,0, 41,0,0,0,0},
                     {1,0x00,4, 92,0,0,0,0},{1,0x33,7,102,0,0,0,0},{1,0x70,1, 35,0,0,0,0},
                     {1,0x07,0, 64,0,0,0,0},{1,0x44,2,118,0,0,0,0},{1,0x70,3,125,0,0,0,0},
                     {2,0x44,5, 73,0,0,0,0},{2,0x33,5,127,0,0,0,0},{2,0x70,4, 65,0,0,0,0},
                     {2,0xb4,4,104,0,0,0,0},{2,0xb9,0, 44,0,0,0,0},{2,0x01,0, 95,0,0,0,0},
                     {2,0xb0,3, 81,0,0,0,0},{2,0x33,0, 23,0,0,0,0},{2,0x70,0,  7,0,0,0,0},
                     {3,0x7b,4, 82,0,0,0,0},{3,0x34,1,122,0,0,0,0},{3,0x24,2, 28,0,0,0,0},
                     {3,0x76,1, 97,0,0,0,0},{3,0xb2,5, 50,0,0,0,0},{3,0x03,0,107,0,0,0,0},
                     {3,0x61,5, 58,0,0,0,0},{3,0x43,4,115,0,0,0,0},{3,0x74,0, 25,0,0,0,0}};

